import Flutter
import UIKit

public class SwiftFlutterClipboardPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "sarbagyastha.com.np/clipboard", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterClipboardPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    let pasteboard = UIPasteboard.general
    switch call.method {
        case "retrieveClipboard":
            if let text = pasteboard.string {
                result(text)
            }
        case "copyToClipboard":
            let args = call.arguments! as! [String:Any]
            pasteboard.string = args["text"] as? String
            result(true)
        default:
            result(FlutterMethodNotImplemented)
    }
  }
}
